(function webpackUniversalModuleDefinition(root, factory) {
	if(typeof exports === 'object' && typeof module === 'object')
		module.exports = factory(require("echarts"), require("angular"));
	else if(typeof define === 'function' && define.amd)
		define(["echarts", "angular"], factory);
	else {
		var a = typeof exports === 'object' ? factory(require("echarts"), require("angular")) : factory(root["echarts"], root["angular"]);
		for(var i in a) (typeof exports === 'object' ? exports : root)[i] = a[i];
	}
})(this, function(__WEBPACK_EXTERNAL_MODULE_1__, __WEBPACK_EXTERNAL_MODULE_2__) {
return /******/ (function(modules) { // webpackBootstrap
/******/ 	// The module cache
/******/ 	var installedModules = {};
/******/
/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {
/******/
/******/ 		// Check if module is in cache
/******/ 		if(installedModules[moduleId]) {
/******/ 			return installedModules[moduleId].exports;
/******/ 		}
/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = installedModules[moduleId] = {
/******/ 			i: moduleId,
/******/ 			l: false,
/******/ 			exports: {}
/******/ 		};
/******/
/******/ 		// Execute the module function
/******/ 		modules[moduleId].call(module.exports, module, module.exports, __webpack_require__);
/******/
/******/ 		// Flag the module as loaded
/******/ 		module.l = true;
/******/
/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}
/******/
/******/
/******/ 	// expose the modules object (__webpack_modules__)
/******/ 	__webpack_require__.m = modules;
/******/
/******/ 	// expose the module cache
/******/ 	__webpack_require__.c = installedModules;
/******/
/******/ 	// define getter function for harmony exports
/******/ 	__webpack_require__.d = function(exports, name, getter) {
/******/ 		if(!__webpack_require__.o(exports, name)) {
/******/ 			Object.defineProperty(exports, name, {
/******/ 				configurable: false,
/******/ 				enumerable: true,
/******/ 				get: getter
/******/ 			});
/******/ 		}
/******/ 	};
/******/
/******/ 	// getDefaultExport function for compatibility with non-harmony modules
/******/ 	__webpack_require__.n = function(module) {
/******/ 		var getter = module && module.__esModule ?
/******/ 			function getDefault() { return module['default']; } :
/******/ 			function getModuleExports() { return module; };
/******/ 		__webpack_require__.d(getter, 'a', getter);
/******/ 		return getter;
/******/ 	};
/******/
/******/ 	// Object.prototype.hasOwnProperty.call
/******/ 	__webpack_require__.o = function(object, property) { return Object.prototype.hasOwnProperty.call(object, property); };
/******/
/******/ 	// __webpack_public_path__
/******/ 	__webpack_require__.p = "";
/******/
/******/ 	// Load entry module and return exports
/******/ 	return __webpack_require__(__webpack_require__.s = 0);
/******/ })
/************************************************************************/
/******/ ([
/* 0 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
Object.defineProperty(__webpack_exports__, "__esModule", { value: true });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_echarts__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_echarts___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_echarts__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_angular__ = __webpack_require__(2);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_angular___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_1_angular__);




var module = __WEBPACK_IMPORTED_MODULE_1_angular___default.a.module('angular.echarts', []);
var component = {
  controller: ChartController,
  bindings: {
    option: '<',
    onCreate: '&'
  }
};

ChartController.$inject = ['$window', '$element', '$scope'];

function ChartController($window, $element, $scope) {
  var ctrl = this;
  $scope.$watch(testVisable, function (v) {
    if (v) {
      if (ctrl.chart) {
        ctrl.chart.resize();
      } else {
        createChart();
      }
    }
  }, true);

  $scope.$watch('$ctrl.option', function (v) {
    if (v && ctrl.chart) {
      setOption();
    }
  }, true);

  ctrl.$postLink = function () {
    $element.css('display', 'block');
    if (testVisable()) {
      createChart();
    }
    __WEBPACK_IMPORTED_MODULE_1_angular___default.a.element($window).on('resize', sizeChanged);
  };

  ctrl.$onDestroy = function () {
    __WEBPACK_IMPORTED_MODULE_1_angular___default.a.element($window).off('resize', sizeChanged);
    ctrl.chart.dispose();
  };

  function createChart() {
    ctrl.chart = __WEBPACK_IMPORTED_MODULE_0_echarts___default.a.init($element[0]);
    if (ctrl.option) {
      setOption();
    }
    ctrl.onCreate({ instance: ctrl.chart });
  }

  function setOption() {
    try {
      ctrl.chart.setOption(ctrl.option);
    } catch (e) {
      $element[0].innerText = 'The option has error!';
      console.error('The option has error!', e);
    }
  }

  function testVisable() {
    return $element[0].offsetWidth > 0 && $element[0].offsetHeight > 0;
  }

  function sizeChanged() {
    if (ctrl.chart) {
      ctrl.chart.resize();
    }
  }
}

module.component('echarts', component);

/* harmony default export */ __webpack_exports__["default"] = ('angular.echarts');

/***/ }),
/* 1 */
/***/ (function(module, exports) {

module.exports = __WEBPACK_EXTERNAL_MODULE_1__;

/***/ }),
/* 2 */
/***/ (function(module, exports) {

module.exports = __WEBPACK_EXTERNAL_MODULE_2__;

/***/ })
/******/ ]);
});